from parameter_util import JSON_BODY, JSON_CONTAINS
from http_util import FAIL, CODE_JSON, CODE_MISSING, CODE_SEMANTIC, CODE_GONE, CODE_NOTFOUND
from room_util import ROOM_GET_CODE

def create():
    parameters = JSON_BODY(request)

    if parameters == None:
        return(FAIL(CODE_JSON))

    if not JSON_CONTAINS(parameters, [('room_code', str), ('user_name', str)]):
        return(FAIL(CODE_MISSING))

    room_code = parameters["room_code"]
    user_name = parameters["user_name"]

    if (len(room_code) != 4) or (len(user_name) == 0) or (len(user_name) > 15):
        return(FAIL(CODE_SEMANTIC))

    room_record = ROOM_GET_CODE(room_code)

    if not room_record:
        return(FAIL(CODE_NOTFOUND))

    db.Player.insert(name=user_name, room_id=room_record.id)
    return(200)
